#include <avr\io.h>
#include <avr\interrupt.h>
#include <util/delay.h>
#include <string.h>


void initialize()
{
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC4);
	
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA4);
	PORTA &= ~(1 << PA5);
	PORTA &= ~(1 << PA6);
	PORTA &= ~(1 << PA7);

	PORTB &= ~(1 << PB0);
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB5);
	PORTB &= ~(1 << PB6);
	PORTB &= ~(1 << PB7);
}


void lightPattern0()
{
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

}

void lightPattern5()
{
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);

	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);
	
}

void lightPattern1()
{
	//top layer
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	initialize();

	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	initialize();
	
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	initialize();
	
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);
	
	initialize();
	
	//second layer
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
		
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	initialize();

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	initialize();
	
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	initialize();
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);
	
	initialize();
	
	//third layer
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);

	initialize();
	
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);

	initialize();

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);
	
	initialize();
	
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);
	
	initialize();
	
	//forth layer
	
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();
	
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();
}


void lightPattern2()
{
	//forth layer
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();
	
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();
	
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();
	
		PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC4);
	_delay_ms(100);
	PORTC &= ~(1 << PC4);

	initialize();

	//third layer

	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);
	
	initialize();
	
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);
	
	initialize();
	
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);

	initialize();

	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC3);
	_delay_ms(100);
	PORTC &= ~(1 << PC3);

	initialize();
	
	//second layer
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);
	
	initialize();
	
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	initialize();
	
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	initialize();

	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
		
	PORTC |= (1<< PC2);
	_delay_ms(100);
	PORTC &= ~(1 << PC2);

	initialize();
	
	//first layer
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);
	
	initialize();
	
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	initialize();

	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	initialize();
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	
	PORTC |= (1<< PC1);
	_delay_ms(100);
	PORTC &= ~(1 << PC1);

	initialize();

}



void lightPattern3()
{
	
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	
	PORTC |= (1<< PC1);
	PORTC |= (1<< PC2);
	PORTC |= (1<< PC3);
	PORTC |= (1<< PC4);
	_delay_ms(500);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC4);
	
	initialize();
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA7);

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC1);
	PORTC |= (1<< PC2);
	PORTC |= (1<< PC3);
	PORTC |= (1<< PC4);
	_delay_ms(500);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC4);

}

void lightPattern4()
{
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA7);

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB7);
	
	PORTC |= (1<< PC1);
	PORTC |= (1<< PC2);
	PORTC |= (1<< PC3);
	PORTC |= (1<< PC4);
	_delay_ms(500);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC4);

	initialize();
	
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	
	PORTC |= (1<< PC1);
	PORTC |= (1<< PC2);
	PORTC |= (1<< PC3);
	PORTC |= (1<< PC4);
	_delay_ms(500);
	PORTC &= ~(1 << PC1);
	PORTC &= ~(1 << PC2);
	PORTC &= ~(1 << PC3);
	PORTC &= ~(1 << PC4);
	
}

void lightPattern6() 
{
	PORTC |= (1<< PC1);
	PORTC |= (1<< PC2);
	PORTC |= (1<< PC3);
	PORTC |= (1<< PC4);
	
	PORTA |= (1 << PA0);
	_delay_ms(50);
	PORTA &= ~(1 << PA0);

	PORTA |= (1 << PA4);
	_delay_ms(50);
	PORTA &= ~(1 << PA4);
	
	PORTB |= (1 << PB0);
	_delay_ms(50);
	PORTB &= ~(1 << PB0);

	PORTB |= (1 << PB4);
	_delay_ms(50);
	PORTB &= ~(1 << PB4);
	
	PORTB |= (1 << PB5);
	_delay_ms(50);
	PORTB &= ~(1 << PB5);
	
	PORTB |= (1 << PB6);
	_delay_ms(50);
	PORTB &= ~(1 << PB6);

	PORTB |= (1 << PB7);
	_delay_ms(50);
	PORTB &= ~(1 << PB7);	

	PORTB |= (1 << PB3);
	_delay_ms(50);
	PORTB &= ~(1 << PB3);

	PORTA |= (1 << PA7);
	_delay_ms(50);
	PORTA &= ~(1 << PA7);

	PORTA |= (1 << PA3);
	_delay_ms(50);
	PORTA &= ~(1 << PA3);

	PORTA |= (1 << PA2);
	_delay_ms(50);
	PORTA &= ~(1 << PA2);	
	
	PORTA |= (1 << PA1);
	_delay_ms(50);
	PORTA &= ~(1 << PA1);
	
	PORTA |= (1 << PA5);
	_delay_ms(50);
	PORTA &= ~(1 << PA5);
	
	PORTB |= (1 << PB1);
	_delay_ms(50);
	PORTB &= ~(1 << PB1);

	PORTB |= (1 << PB2);
	_delay_ms(50);
	PORTB &= ~(1 << PB2);

	PORTA |= (1 << PA6);
	_delay_ms(50);
	PORTA &= ~(1 << PA6);

	initialize();
}

int main()
{

	DDRA = 0xFF;
	DDRB = 0xFF;

	initialize();
	
	while (1) {
	
		lightPattern0();
		initialize();
		_delay_ms(500);
		
		lightPattern5();
		initialize();
		_delay_ms(500);
		
		lightPattern1();
		initialize();
		_delay_ms(500);

		lightPattern2();
		initialize();
		_delay_ms(500);

		lightPattern3();
		initialize();
		_delay_ms(500);
		
		lightPattern4();
		initialize();
		_delay_ms(500);
		
		int i;
		
		for (i=0; i<3; i++) {
		
			lightPattern6();
			initialize();
			_delay_ms(500);
		}
	}
	
	return 0;
}

